unit MainUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls, ExtCtrls, ImgList;

type
  TMainForm = class(TForm)
    GroupBox1: TGroupBox;
    AOutCheck: TCheckBox;
    ReadTime: TTimer;
    BOutCheck: TCheckBox;
    COutRadio: TRadioButton;
    DOutRadio: TRadioButton;
    TristateACheck: TCheckBox;
    TristateBCDFastCheck: TCheckBox;
    LevelImage0: TImage;
    LevelImage1: TImage;
    LevelImage2: TImage;
    LevelImage3: TImage;
    LevelImage4: TImage;
    LevelImage5: TImage;
    LevelImage6: TImage;
    LevelImage7: TImage;
    LevelImage8: TImage;
    LevelImage9: TImage;
    LevelImage10: TImage;
    LevelImage11: TImage;
    LevelImage16: TImage;
    LevelImage17: TImage;
    LevelImage18: TImage;
    LevelImage24: TImage;
    LevelImage25: TImage;
    LevelImage26: TImage;
    BitLabelA7: TLabel;
    BitLabelA6: TLabel;
    BitLabelA5: TLabel;
    BitLabelA4: TLabel;
    BitLabelA3: TLabel;
    BitLabelA2: TLabel;
    BitLabelA1: TLabel;
    BitLabelA0: TLabel;
    BitLabelB3: TLabel;
    BitLabelB2: TLabel;
    BitLabelB1: TLabel;
    BitLabelB0: TLabel;
    BitLabelC2: TLabel;
    BitLabelC1: TLabel;
    BitLabelC0: TLabel;
    BitLabelD2: TLabel;
    BitLabelD1: TLabel;
    BitLabelD0: TLabel;
    LevelImages: TImageList;
    GroupBox2: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    Label19: TLabel;
    Label20: TLabel;
    Label21: TLabel;
    Label22: TLabel;
    Label23: TLabel;
    Label24: TLabel;
    Label25: TLabel;
    Label26: TLabel;
    Label27: TLabel;
    Label28: TLabel;
    Label29: TLabel;
    Label30: TLabel;
    Label31: TLabel;
    Label32: TLabel;
    Label33: TLabel;
    Label34: TLabel;
    Label35: TLabel;
    Label36: TLabel;
    Label37: TLabel;
    Label38: TLabel;
    Label39: TLabel;
    Label40: TLabel;
    Label41: TLabel;
    Label42: TLabel;
    Label43: TLabel;
    Label44: TLabel;
    Label45: TLabel;
    Label46: TLabel;
    Label47: TLabel;
    Label48: TLabel;
    HighTrack0: TTrackBar;
    LowTrack0: TTrackBar;
    HighTrack1: TTrackBar;
    LowTrack1: TTrackBar;
    HighTrack2: TTrackBar;
    LowTrack2: TTrackBar;
    HighTrack3: TTrackBar;
    LowTrack3: TTrackBar;
    HighTrack4: TTrackBar;
    LowTrack4: TTrackBar;
    HighTrack5: TTrackBar;
    LowTrack5: TTrackBar;
    HighTrack6: TTrackBar;
    LowTrack6: TTrackBar;
    HighTrack7: TTrackBar;
    LowTrack7: TTrackBar;
    HighTrack8: TTrackBar;
    LowTrack8: TTrackBar;
    HighTrack9: TTrackBar;
    LowTrack9: TTrackBar;
    HighTrack10: TTrackBar;
    LowTrack10: TTrackBar;
    HighTrack11: TTrackBar;
    LowTrack11: TTrackBar;
    HighTrack12: TTrackBar;
    LowTrack12: TTrackBar;
    HighTrack13: TTrackBar;
    LowTrack13: TTrackBar;
    HighTrack14: TTrackBar;
    LowTrack14: TTrackBar;
    HighTrack15: TTrackBar;
    LowTrack15: TTrackBar;
    EndButton: TButton;
    BeginButton: TButton;
    procedure FormCreate(Sender: TObject);
    procedure SideTrackChange(Sender: TObject);
    procedure ReadTimeTimer(Sender: TObject);
    procedure LevelImageClick(Sender: TObject);
    procedure BeginButtonClick(Sender: TObject);
    procedure EndButtonClick(Sender: TObject);
    procedure OutControlClick(Sender: TObject);
    procedure TristateCheckClick(Sender: TObject);
  protected
    procedure DoConfig;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

{$R *.DFM}

uses
  AIOUSB,
  BitPulseStreamers;

var
  LevelImage: array[0..31] of TImage; //Only some are actually stuffed, the others will be nil
  HighTrack, LowTrack: array[0..15] of TTrackBar;
  LowLevel, HighLevel: TBitmap;
  DeviceIndex: LongWord;
  DIOData: LongWord;
  bForceUpdate: Boolean;

procedure TMainForm.FormCreate(Sender: TObject);
begin
  LevelImage[ 0] := LevelImage0;
  LevelImage[ 1] := LevelImage1;
  LevelImage[ 2] := LevelImage2;
  LevelImage[ 3] := LevelImage3;
  LevelImage[ 4] := LevelImage4;
  LevelImage[ 5] := LevelImage5;
  LevelImage[ 6] := LevelImage6;
  LevelImage[ 7] := LevelImage7;
  LevelImage[ 8] := LevelImage8;
  LevelImage[ 9] := LevelImage9;
  LevelImage[10] := LevelImage10;
  LevelImage[11] := LevelImage11;
  LevelImage[16] := LevelImage16;
  LevelImage[17] := LevelImage17;
  LevelImage[18] := LevelImage18;
  LevelImage[24] := LevelImage24;
  LevelImage[25] := LevelImage25;
  LevelImage[26] := LevelImage26;

  HighTrack[ 0] := HighTrack0;  LowTrack[ 0] := LowTrack0;
  HighTrack[ 1] := HighTrack1;  LowTrack[ 1] := LowTrack1;
  HighTrack[ 2] := HighTrack2;  LowTrack[ 2] := LowTrack2;
  HighTrack[ 3] := HighTrack3;  LowTrack[ 3] := LowTrack3;
  HighTrack[ 4] := HighTrack4;  LowTrack[ 4] := LowTrack4;
  HighTrack[ 5] := HighTrack5;  LowTrack[ 5] := LowTrack5;
  HighTrack[ 6] := HighTrack6;  LowTrack[ 6] := LowTrack6;
  HighTrack[ 7] := HighTrack7;  LowTrack[ 7] := LowTrack7;
  HighTrack[ 8] := HighTrack8;  LowTrack[ 8] := LowTrack8;
  HighTrack[ 9] := HighTrack9;  LowTrack[ 9] := LowTrack9;
  HighTrack[10] := HighTrack10; LowTrack[10] := LowTrack10;
  HighTrack[11] := HighTrack11; LowTrack[11] := LowTrack11;
  HighTrack[12] := HighTrack12; LowTrack[12] := LowTrack12;
  HighTrack[13] := HighTrack13; LowTrack[13] := LowTrack13;
  HighTrack[14] := HighTrack14; LowTrack[14] := LowTrack14;
  HighTrack[15] := HighTrack15; LowTrack[15] := LowTrack15;

  LowLevel := TBitmap.Create;
  HighLevel := TBitmap.Create;

  DIO_StreamOpen(DeviceIndex, False);
  DIO_StreamClose(DeviceIndex);
  DoConfig;

  ClearBitPulses;

  bForceUpdate := True;
  ReadTime.Enabled := True;
end;

procedure TMainForm.SideTrackChange(Sender: TObject);
var
  BitIndex: Integer;

begin
  BitIndex := (Sender as TTrackBar).Tag;

  SetBitPulse(BitIndex, HighTrack[BitIndex].Position, LowTrack[BitIndex].Position);
end;

procedure TMainForm.BeginButtonClick(Sender: TObject);
begin
  //`@
end;

procedure TMainForm.EndButtonClick(Sender: TObject);
begin
  //`@
end;

procedure TMainForm.ReadTimeTimer(Sender: TObject);
var
  I: Integer;
  oDIOData, Changes: LongWord;

begin
  oDIOData := DIOData;
  DIO_ReadAll(DeviceIndex, @DIOData);
  Changes := DIOData xor oDIOData;

  if bForceUpdate then begin
    Changes := $FFFFFFFF;
    bForceUpdate := False;
  end;

  for I := 0 to 31 do
    if LevelImage[I] <> nil then
      if (Changes and (1 shl I)) <> 0 then begin
        if (DIOData and (1 shl I)) <> 0 then
          LevelImage[I].Picture.Assign(HighLevel)
        else
          LevelImage[I].Picture.Assign(LowLevel)
      end
  ;
end;

procedure TMainForm.LevelImageClick(Sender: TObject);
var
  I: Integer;
  NewValue: Boolean;

begin
  I := (Sender as TImage).Tag;
  DIOData := DIOData xor (1 shl I); //Toggle bit
  NewValue := (DIOData and (1 shl I)) <> 0; //Get new bit value
  DIO_Write1(DeviceIndex, I, NewValue); //Write it to the board
  bForceUpdate := True;
end;

procedure TMainForm.OutControlClick(Sender: TObject);
var
  I: Integer;

begin
  I := (Sender as TButtonControl).Tag;
  if I < 4 then
    DIOData := DIOData or ($FF shl (I * 8)) //Set new output byte high, in case user made a mistake; ignored for inputs
  ;

  DoConfig;
end;

procedure TMainForm.TristateCheckClick(Sender: TObject);
begin
  DoConfig;
end;

procedure TMainForm.DoConfig;
var
  OutMask, TristateMask: Byte;

begin
  OutMask := $00;
  if AOutCheck.Checked then OutMask := OutMask or $1;
  if BOutCheck.Checked then OutMask := OutMask or $2;
  if COutRadio.Checked then OutMask := OutMask or $4;
  if DOutRadio.Checked then OutMask := OutMask or $8;

  TristateMask := $00;
  if TristateACheck.Checked then TristateMask := TristateMask or 1;
  if TristateBCDFastCheck.Checked then TristateMask := TristateMask or 2;

  DIO_ConfigureEx(DeviceIndex, @OutMask, @DIOData, @TristateMask);
  bForceUpdate := True;
end;

end.
